
LvDoHeader          PROTO :HWND,:UINT,:WPARAM,:LPARAM
LvGetItemText       PROTO :HWND,:DWORD,:DWORD
LvCreateProgressBar PROTO :HWND,:DWORD,:DWORD
AddItem             PROTO :HWND,:DWORD,:DWORD
.data
.data?
hListOldProc     dd ?
.code

LvInsertHeader PROC hWnd:DWORD
LOCAL lvc:LV_COLUMN
 invoke SendMessage,hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_FULLROWSELECT
	mov lvc.imask,LVCF_TEXT+LVCF_WIDTH
	mov lvc.pszText,offset szListText
	mov lvc.lx,80
 invoke SendMessage,hWnd, LVM_INSERTCOLUMN,0,addr lvc
	 or lvc.imask,LVCF_FMT
	mov lvc.fmt,LVCFMT_LEFT ;CENTER
	mov lvc.pszText,offset szListInfo
	mov lvc.lx,100
 invoke SendMessage,hWnd, LVM_INSERTCOLUMN, 1 ,addr lvc
	mov lvc.pszText,offset szListProgress
	mov lvc.lx,110
 invoke SendMessage,hWnd, LVM_INSERTCOLUMN, 2 ,addr lvc
    ret
LvInsertHeader endp 

;disable column re-sizing
LvDoHeader PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

.if uMsg==WM_LBUTTONDOWN
    invoke CallWindowProc,hListOldProc,hWnd,NULL,NULL,NULL
  .elseif uMsg==WM_SETCURSOR
          invoke CallWindowProc,hListOldProc,hWnd,NULL,NULL,NULL
   .else
          invoke CallWindowProc,hListOldProc,hWnd,uMsg,wParam,lParam
.endif
ret
LvDoHeader ENDP

LvGetItemText	PROC hWnd:DWORD,iIndex:DWORD,iSub:DWORD
LOCAL Lvi :LV_ITEM
LOCAL lpBuffer[260]:BYTE
   push ebx
 invoke RtlZeroMemory,addr lpBuffer,260
 invoke RtlZeroMemory,addr Lvi,sizeof Lvi
	mov ebx,iIndex
	mov Lvi.iItem,ebx
	mov ebx,iSub
	mov Lvi.iSubItem,ebx
	mov Lvi.imask,LVIF_TEXT
	lea eax,lpBuffer
	mov Lvi.pszText,eax
	mov Lvi.cchTextMax,260
 invoke SendMessage,hWnd,LVM_GETITEM,NULL,addr Lvi
	lea eax,lpBuffer
	pop ebx
	ret
LvGetItemText endp

LvCreateProgressBar	PROC hWnd:DWORD, itm_index:DWORD,ProgressBarID:DWORD
LOCAL rc:RECT
	pushad
	mov	ebx,itm_index	
	mov rc.top,2	
   	mov rc.left,LVIR_BOUNDS
    lea	ecx,[ebx+1]
 invoke SendMessage,hWnd,LVM_GETSUBITEMRECT,ecx,addr rc
    mov edi,eax
    mov ecx,[rc.right]
    sub ecx,[rc.left]
    sub [rc.top],-1
    sub ecx,10
    add [rc.left],5
 invoke CreateWindowEx,NULL, CTEXT ("msctls_progress32"),NULL,\ 
	    WS_CHILD+WS_VISIBLE,\
	    rc.left, rc.top, ecx, 12,hWnd,ProgressBarID ,\ 
	   NULL,NULL 
 invoke UpdateWindow, hWnd
  popad
	ret
LvCreateProgressBar	endp


LvAddItem PROC hWnd:DWORD,pText:DWORD,pInfo:DWORD
LOCAL Item :LV_ITEM
 pushad
    mov	Item .imask,LVIF_TEXT
    mov	Item.iItem,ebx
    mov ebx,pText
    mov	Item .pszText,ebx
    mov	Item .iSubItem,NULL
 invoke	SendMessage,hWnd,LVM_INSERTITEM,NULL,addr Item 
    mov	Item.iItem,eax
    
    inc	Item.iSubItem
    mov ebx,pInfo
	mov	Item.pszText,ebx
 invoke	SendMessage,hWnd,LVM_SETITEM,NULL,addr Item 
 
 invoke SendMessage,hWnd,LVM_GETITEMCOUNT, NULL, NULL
    mov esi ,eax
    dec Item.iItem
 invoke LvCreateProgressBar,hWnd,Item.iItem,esi
  popad
    ret   
LvAddItem ENDP